-- thanks goes to creators of BigWigs_Plugins/bars.lua and Chronometer
-- keep wowace alive, donate!

SpellReminder = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceHook-2.1", "AceConsole-2.0", "AceEvent-2.0", "FuBarPlugin-2.0", "Parser-3.0", "Sink-1.0")
local SpellReminder, self = SpellReminder, SpellReminder
local BS = AceLibrary("Babble-Spell-2.2")
local candybar = AceLibrary("CandyBar-2.0")
local sm = AceLibrary("SharedMedia-1.0")

SpellReminder:RegisterDB("SpellReminderDB","SpellReminderDBPerChar")
SpellReminder:RegisterDefaults('profile', {
	startScale	= 1,
	stopScale	= 1.5,
	ttg			= 0.3,
	growup		= false,
	lockbars	= false,
	debugmode	= false,
	disableEmphasis = false,
	textFormat	= "%n (%t)(%a)",
	texture		= "Blizzard",
	baroverride	= false,
	barfont		= nil,
	barfontsize	= 11,
	barwidth	= 200,
	barheight	= 16,
	disableDetection	= true,
	barposition	= { normal = {} , emphasis = {} },
})
SpellReminder:RegisterDefaults('char', {
	spellSetup	= {},
})

SpellReminder.hideWithoutStandby = true;
SpellReminder.hasNoColor = true;
SpellReminder.hasIcon = "Interface\\Icons\\Ability_Warrior_BattleShout"
local defaultBarColor = {["r"] = 1, ["g"] = 0, ["b"] = 0, ["a"] = 1}

-- stores information PER SPELL[Target]
local spellInfo = {
	casting = {},
	active = {},
}

local function getOption(key)
	return SpellReminder.db.profile[key]
end
local function setOption(key, value)
	SpellReminder.db.profile[key] = value
end
local defaultSpells = {
	type = "group",
	order = 1,
	name = "Spell Setup",
	desc = "Setup spell reminders.",
	args = {
		spacer = { type = "header", order = 100 },
		--[[addNew = {
			type = "text",
			order = 101,
			name = "Add New Spell",
			desc = "Add a new spell to the watch list.",
			usage = "<name>",
			get = function () return "" end,
			set = function (v) SpellReminder:InstallWatch(v) SpellReminder:BuildSpellOptions() end,
		},]]
		disableDetection = {
			type = "toggle",
			order = 103,
			name = "Disable Detection",
			desc = "Disables the detection of new spells",
			get = getOption,
			set = setOption,
			passValue = "disableDetection",
		},
		spacer2 = { type = "header", order = 105 },
		ClearAll = {
			type = "execute",
			order = 110,
			name = "Clear All Spells",
			desc = "Will force SpellReminder to forget all options for ALL spells, including detected spells and pet spells.",
			func = function () SpellReminder:ClearSpells(true) end,
		},
		addAll = {
			type = "execute",
			order = 115,
			name = "Scan Spellbook",
			desc = "Attempts to scan your spellbook and watch all spells.",
			func = "InstallAllSpells",
		},
	},
}
SpellReminder.options = {
	type = "group",
	name = "SpellReminder",
	desc = "Options for SpellReminder.",
	handler = SpellReminder,
	args = {
		spells = defaultSpells,
		spacer2 = { type = "header", order = 2 },
		animGroup = {
			type = "group",
			order = 3,
			name = "Timer Bars",
			desc = "Setup bar animation options and scaling.",
			args = {
				startScale = {				
					type = "range",
					order = 1,
					name = "Start Scale",
					desc = "Default Bar Scale.",
					min = 0.2,
					max = 2.0,
					step = 0.1,
					get = getOption,
					set = setOption,
					passValue = "startScale",
				},
				disableEmphasis = {
					type = "toggle",
					order = 2,
					name = "Disable Emphasis",
					desc = "Disables the emphasise effect",
					get = getOption,
					set = setOption,
					passValue = "disableEmphasis",
				},
				stopScale = {
					type = "range",
					order = 3,
					name = "Emphasize Scale",
					desc = "Emphasized Bar Scale.",
					disabled = function () return getOption("disableEmphasis") == true end,
					min = 0.2,
					max = 3.0,
					step = 0.1,
					get = getOption,
					set = setOption,
					passValue = "stopScale",
				},
				ttg = {
					type = "range",
					order = 4,
					name = "Tween Time",
					desc = "Total time of tween animation.",
					disabled = function () return getOption("disableEmphasis") == true end,
					min = 0.1,
					max = 3.0,
					step = 0.1,
					get = getOption,
					set = setOption,
					passValue = "ttg",
				},
				spacer2 = { type = "header", order = 5 },
				growUp = {
					type = "toggle",
					order = 6,
					name = "Grow Up",
					desc = "Instructs the timer bars to grow upward instead of downward",
					get = function ()  return getOption("growup") end,
					set = function (v)
						setOption("growup",v)
						candybar:SetCandyBarGroupGrowth("SpellReminderNormal", getOption("growup"))
						candybar:SetCandyBarGroupGrowth("SpellReminderEmphasis", getOption("growup"))
					end,
				},
				lockBars = {
					type = "toggle",
					order = 7,
					name = "Lock timer bars",
					desc = "Lock the position of the timer bars.",
					get = function () return getOption("lockbars") end,
					set = function (v)
						setOption("lockbars",v)
						-- show/hide the anchors
						SpellReminder:ToggleAnchors()
					end
				},
				resetBars = {
					type = "execute",
					order = 8,
					name = "Reset Bars",
					desc = "Reset the posion of the bars.",
					func = "ResetAnchors",
				},
				testBars = {
					type = "execute",
					order = 9,
					name = "Test Bars",
					desc = "Create sample reminder bars to test your layout.",
					func = "CreateTestBars",
				},
				spacer1 = { type = "header", order = 10 },
				textFormat = {
					type = 'text',
					name = "Display Text",
					desc = "Set the format of the text that appears on the bars.  Possible values are: %n (spell name) %r (spell rank) %t (target) %a (applications)",
					usage = "<format>",
					order = 11,
					get = getOption,
					set = setOption,
					passValue = 'textFormat',
				},
				texture = {
					type = 'text',
					name = "Texture",
					desc = "Set the Cast Bar Texture",
					validate = sm:List('statusbar'),
					order = 12,
					get = getOption,
					set = setOption,
					passValue = 'texture',
				},
				spacer3 = { type = "header", order = 100 },
				baroverride = {
					type = "toggle",
					order = 105,
					name = "Override Bar",
					desc = "Override the candybar defaults.",
					get = getOption,
					set = setOption,
					passValue = "baroverride",
				},
				barwidth = {
					type = 'range',
					name = "Bar Width",
					desc = "Set the Cast Bar Width",
					order = 110,
					disabled = function () return getOption("baroverride") == false end,
					min = 50,
					max = 500,
					step = 10,
					get = getOption,
					set = setOption,
					passValue = 'barwidth',
				},
				barheight = {
					type = 'range',
					name = "Bar Height",
					desc = "Set the Cast Bar Height",
					order = 115,
					disabled = function () return getOption("baroverride") == false end,
					min = 5,
					max = 40,
					step = 1,
					get = getOption,
					set = setOption,
					passValue = 'barheight',
				},
				spacer4 = { type = "header", order = 120 },
				barfont = {
					type = 'text',
					name = "Font",
					desc = "Set the Cast Bar Font",
					validate = sm:List('font'),
					order = 125,
					disabled = function () return getOption("baroverride") == false end,
					get = getOption,
					set = setOption,
					passValue = 'barfont',
				},
				barfontsize = {
					type = 'range',
					name = "Font Size",
					desc = "Set the Cast Bar Font Size",
					order = 130,
					disabled = function () return getOption("baroverride") == false end,
					min = 1,
					max = 30,
					step = 1,
					get = getOption,
					set = setOption,
					passValue = 'barfontsize',
				},
			},
		},
--		spacer3 = { type = "header", order = 4 },
		debugmode = {
			type = "toggle",
			order = 5,
			name = "Debug Mode",
			desc = "Show Debug Messages.",
			get = function () return getOption("debugmode") end,
			set = function (v) setOption("debugmode",v) end,
		},
		spacer4 = { type = "header", order = 6 },
	},
}

function SpellReminder:OnInitialize()
    -- Called when the addon is loaded
	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_STOP")
	self:RegisterEvent("UNIT_SPELLMISS")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("PLAYER_DEAD")
	self:RegisterParserEvent({eventType = "Death"},"COMBAT_DEATH")

	
	self:RegisterEvent("SpecialEvents_UnitBuffLost","SE_AURA_LOST")
	self:RegisterEvent("SpecialEvents_PlayerItemBuffLost","SE_ITEM_AURA_LOST")

	self:RegisterEvent("PLAYER_AURAS_CHANGED",function() self:ProcessAuras("player") end)
	self:RegisterEvent("PLAYER_TARGET_CHANGED",function() self:ProcessAuras("target") end)
	self:RegisterEvent("UNIT_AURA",function(unit) self:ProcessAuras(unit) end)
	self:RegisterEvent("UNIT_PET",function(unit) self:DebugPrint("Pet changed, rescanning") if unit == "player" then self:InstallAllSpells() end end)
	self:RegisterEvent("CHARACTER_POINTS_CHANGED","InstallAllSpells")
	self:RegisterEvent("LEARNED_SPELL_IN_TAB","InstallAllSpells")
--CHAT_MSG_SPELL_SELF_DAMAGE

	self:RegisterChatCommand({'/SpellReminder'}, self.options)
	self.OnMenuRequest = self.options
--[[	self:RegisterChatCommand('/SpellReminder', {
		type = 'execute',
		func = function()
			self:OpenMenu()
		end
	})]]
	
	self:CreateAnchors()
end

function SpellReminder:OnEnable()
    -- Called when the addon is enabled
--	self:ClearSpells(false)
--	self:InstallAllSpells()
end

function SpellReminder:ProcessAuras(unit)
	self:DebugPrint("ProcessAuras")
	local i = 1
	while UnitExists(unit) and (UnitBuff(unit, i) ~= nil) do
		name, rank, iconTexture, applications, duration, timeLeft = UnitBuff(unit, i);
		local info = self.db.char.spellSetup[name]
		if info == nil and (getOption("disableDetection") == false) and duration ~= nil and duration > 0 then
			self:Print("Detected new spell! ("..name..")")
			self:InstallWatch(name,rank,nil,duration)
			info = self.db.char.spellSetup[name]
			if select(1,self:GetDuration(name,rank)) == nil then self.db.char.spellSetup[name].detected = true end
			self:BuildSpellOptions()
		end
		if duration == nil and unit == "player" then duration = self:GetPlayerBuffDuration(name) end
		if info ~= nil and info.active == true then --and duration ~= nil then
			if duration == nil then duration = info.d end
			if timeLeft ~= nil then
				castingInfo = {n=name, displayName=info.displayName, icon=iconTexture, ["applications"]=applications, r=info.r, ["rank"]=rank, t=UnitName(unit), eventName="DURATION_ENDING_"..name..";"..UnitName(unit), c=info.c}
				spellInfo.active[castingInfo.eventName] = castingInfo
				self:CreateReminderBar(castingInfo.eventName, castingInfo, duration, info.r, info.c, timeLeft)
			else
				self:OnDurationEnded("DURATION_ENDING_"..name..";"..UnitName(unit),true)
			end -- not your spell
		end
		i = i + 1
	end
	
	local i = 1
	while UnitExists(unit) and (UnitDebuff(unit, i) ~= nil) do
		name, rank, texture, applications, debuffType, duration, timeLeft = UnitDebuff(unit, i);
		local info = self.db.char.spellSetup[name]
		if info == nil and (getOption("disableDetection") == false) and duration ~= nil and duration > 0 then
			self:Print("Detected new spell! ("..name..")")
			self:InstallWatch(name,rank,nil,duration)
			info = self.db.char.spellSetup[name]
			if select(1,self:GetDuration(name,rank)) == nil then self.db.char.spellSetup[name].detected = true end
			self:BuildSpellOptions()
		end
		-- if info is nil, then we just detected a new spell!  gogo install it
		if info ~= nil and info.active == true then --and duration ~= nil then
			if timeLeft ~= nil then
				castingInfo = {n=name, displayName=name, icon=texture, ["applications"]=applications, r=duration*0.125, ["rank"]=rank, t=UnitName(unit), eventName="DURATION_ENDING_"..name..";"..UnitName(unit), c=info.c}
				spellInfo.active[castingInfo.eventName] = castingInfo
				self:CreateReminderBar(castingInfo.eventName, castingInfo, duration, castingInfo.r, info.c, timeLeft)
			else -- not your spell
				self:OnDurationEnded("DURATION_ENDING_"..name..";"..UnitName(unit),true)
			end
		end
		i = i + 1
	end
	
	if unit ~= "player" or true then return end -- not yet working, break out
	hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo()
	if hasMainHandEnchant then
		_, textureName = GetInventorySlotInfo("MainHandSlot")
		castingInfo = {n="MH Buff", displayName="MH Buff", icon=textureName, ["applications"]=mainHandCharges, r=mainHandExpiration*0.125, t=UnitName(unit), eventName="DURATION_ENDING_"..name..";"..UnitName(unit)}
		spellInfo.active[castingInfo.eventName] = castingInfo
		self:CreateReminderBar(castingInfo.eventName, castingInfo, mainHandExpiration, castingInfo.r, nil, mainHandExpiration)
	end
	if hasOffHandEnchant then
		_, textureName = GetInventorySlotInfo("SecondaryHandSlot")
		castingInfo = {n="OH Buff", displayName="OH Buff", icon=textureName, ["applications"]=offHandCharges, r=offHandExpiration*0.125, t=UnitName(unit), eventName="DURATION_ENDING_"..name..";"..UnitName(unit)}
		spellInfo.active[castingInfo.eventName] = castingInfo
		self:CreateReminderBar(castingInfo.eventName, castingInfo, offHandExpiration, castingInfo.r, nil, offHandExpiration)
	end
end
--[[function SpellReminder:ProcessAuras()
	self:DebugPrint("ProcessAuras")
	i = 1
	while (GetPlayerBuff(i,"HELPFUL") > 0) do
		buffIndex, untilCancelled =  GetPlayerBuff(i,"HELPFUL")
		name, texture, applications, timeLeft = GetPlayerBuffName(buffIndex), GetPlayerBuffTexture(buffIndex), GetPlayerBuffApplications(buffIndex), GetPlayerBuffTimeLeft(buffIndex)
		duration = self:GetPlayerBuffDuration(name)
		local info = self.db.char.spellSetup[name]
		if info ~= nil and info.active == true and duration ~= nil then
			castingInfo = {n=name, displayName=info.displayName, r=info.r, ["rank"]=rank, t=UnitName("player"), eventName="DURATION_ENDING_"..name..";"..UnitName("player"), c=info.c}
			spellInfo.active[castingInfo.eventName] = castingInfo
			self:CreateReminderBar(castingInfo.eventName, castingInfo, duration, info.r, info.c, timeLeft)
		end
		i = i + 1;
	end
end]]

function SpellReminder:PLAYER_LOGIN()
	self:ScheduleEvent(self.ProcessAuras,0.5,self,"player")
end

function SpellReminder:OnDisable()
--[[
    -- Called when the addon is disabled
	self:UnregisterEvent("PLAYER_LOGIN")
	self:UnregisterEvent("UNIT_SPELLCAST_SENT")
	self:UnregisterEvent("UNIT_SPELLCAST_STOP")
	self:UnregisterEvent("UNIT_SPELLMISS")
	self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:UnregisterEvent("PLAYER_DEAD")
	self:UnregisterParserEvent({eventType = "Death"},"COMBAT_DEATH")

	
	self:UnregisterEvent("SpecialEvents_UnitBuffLost","SE_AURA_LOST")
	self:UnregisterEvent("SpecialEvents_PlayerItemBuffLost","SE_ITEM_AURA_LOST")

	self:UnregisterEvent("PLAYER_AURAS_CHANGED",function() self:ProcessAuras("player") end)
	self:UnregisterEvent("PLAYER_TARGET_CHANGED",function() self:ProcessAuras("target") end)
	self:UnregisterEvent("UNIT_AURA",function(unit) self:ProcessAuras(unit) end)
	self:UnregisterEvent("UNIT_PET",function(unit) self:DebugPrint("Pet changed, rescanning") if unit == "player" then self:InstallAllSpells() end end)
	self:UnregisterEvent("CHARACTER_POINTS_CHANGED","InstallAllSpells")
	self:UnregisterEvent("LEARNED_SPELL_IN_TAB","InstallAllSpells")

	-- stop all spell watch events
--	table.foreach(self.db.char.spellSetup, function(k,v) self:CancelWatchSpell(k) end)
	candybar:UnregisterCandyBarGroup("SpellReminderNormal")
	candybar:UnregisterCandyBarGroup("SpellReminderEmphasis")
	]]
end

function SpellReminder:CreateAnchors()
	self.normalAnchor = self:CreateAnchor("normal","Normal Bars",0.3,1,0.3)
	self.emphasisAnchor = self:CreateAnchor("emphasis","Emphasised Bars",0.3,1,0.3)

	-- setup candybar
	candybar:RegisterCandyBarGroup("SpellReminderNormal")
	candybar:SetCandyBarGroupPoint("SpellReminderNormal", "TOP", self.normalAnchor, "BOTTOM", 0, 0)	
	candybar:SetCandyBarGroupGrowth("SpellReminderNormal", getOption("growup"))
	
	candybar:RegisterCandyBarGroup("SpellReminderEmphasis")
	candybar:SetCandyBarGroupPoint("SpellReminderEmphasis", "TOP", self.emphasisAnchor, "BOTTOM", 0, 0)	
	candybar:SetCandyBarGroupGrowth("SpellReminderEmphasis", getOption("growup"))

	self:ToggleAnchors()
end

function SpellReminder:ResetAnchors()
	if not getOption("lockbars") then self:ToggleAnchors() end
	local s = this:GetEffectiveScale()
	self.normalAnchor:ClearAllPoints()
	self.normalAnchor:SetPoint("CENTER", 0, 50 /s)
	self.emphasisAnchor:ClearAllPoints()
	self.emphasisAnchor:SetPoint("CENTER", 0, 150 /s)
	self:SaveAnchorPositions()
end

function SpellReminder:ToggleAnchors()
	if getOption("lockbars") then
		self.normalAnchor:Hide()
		self.emphasisAnchor:Hide()
	else
		self.normalAnchor:Show()
		self.emphasisAnchor:Show()
	end
end

function SpellReminder:SaveAnchorPositions()
	local s = this:GetEffectiveScale()
	local point, _, anchor, x, y = self.normalAnchor:GetPoint()
	self.db.profile.barposition["normal"].x = x * s
	self.db.profile.barposition["normal"].y = y * s
	self.db.profile.barposition["normal"].anchor = anchor
	self.db.profile.barposition["normal"].point = point
	
	local point, _, anchor, x, y = self.emphasisAnchor:GetPoint()
	self.db.profile.barposition["emphasis"].x = x * s
	self.db.profile.barposition["emphasis"].y = y * s
	self.db.profile.barposition["emphasis"].anchor = anchor
	self.db.profile.barposition["emphasis"].point = point
end

function SpellReminder:CreateAnchor(name, text, cRed, cGreen, cBlue)
	local f = CreateFrame("Button", "SpellReminder_"..name.."Anchor", UIParent)
	f:SetWidth(200)
	f:SetHeight(25)

	f.owner = self

	local s = this:GetEffectiveScale()
	f:ClearAllPoints()
	if self.db.profile.barposition[name].x and self.db.profile.barposition[name].y and self.db.profile.barposition[name].point and self.db.profile.barposition[name].anchor then
		f:SetPoint(self.db.profile.barposition[name].point, UIParent, self.db.profile.barposition[name].anchor, self.db.profile.barposition[name].x/s, self.db.profile.barposition[name].y/s)
	else
		f:SetPoint("CENTER", UIParent, "CENTER", 0, 50/s)
	end

	f:SetScript("OnDragStart", function() this:StartMoving() end )
	f:SetScript("OnDragStop",
		function()
			this:StopMovingOrSizing()
			self:SaveAnchorPositions()
        end)

	f:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
                                            tile = false, tileSize = 16, edgeSize = 16,
                                            insets = { left = 5, right =5, top = 5, bottom = 5 }})
	f:SetBackdropColor(cRed,cGreen,cBlue,.6)
	f:SetMovable(true)
	f:RegisterForDrag("LeftButton")

	f.Text = f:CreateFontString(nil, "OVERLAY")
	f.Text:SetFontObject(GameFontNormalSmall)
	f.Text:ClearAllPoints()
	f.Text:SetTextColor(1, 1, 1, 1)
	f.Text:SetWidth(200)
	f.Text:SetHeight(25)
	f.Text:SetPoint("TOPLEFT", f, "TOPLEFT")
	f.Text:SetJustifyH("CENTER")
	f.Text:SetJustifyV("MIDDLE")
	f.Text:SetText(text)

	f:Hide()

	return f
end

function SpellReminder:CreateTestBars()
	self:CreateReminderBar("TEST_MANUAL",{n="Test"},30, 10)
	local i,added = 1,0
	while true do
		if added == 3 then break end
		local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spell) then	break end
		local durationBuff, durationDebuff = self:GetDuration(spell)
		if durationBuff ~= nil and durationBuff <= 30 then
			self:CreateReminderBar("TEST"..added,{n=spell,["rank"]=rank},durationBuff,math.ceil(durationBuff*.125),{r=math.random(),g=math.random(),b=math.random()})
			added = added + 1
		end
		i = i + 1
	end
end

function SpellReminder:ClearSpells(clearAll)
	table.foreach(self.db.char.spellSetup, function (spellName,info)
		if (clearAll == true) then self:ClearSpell(spellName) return end
		if (info.detected) then return end
		--self.db.char.spellSetup[spellName] = nil
		local found = false
		local i = 1
		while true do
			local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
			if (not spell) then	break end
			if spell == spellName then
				found = true
			end
			i = i + 1
		end
		
	--[[	local i = 1
		while true do
			local spell, rank = GetSpellName(i, BOOKTYPE_PET)
			if (not spell) then	break end
			if spell == spellName then
				found = true
			end
			i = i + 1
		end]]
		if found == false then self:ClearSpell(spellName) end
	end)
	
	SpellReminder:BuildSpellOptions()
end

function SpellReminder:ClearSpell(spellName)
	self.db.char.spellSetup[spellName] = nil
	self.options.args.spells.args["spell_"..string.gsub(spellName," ","_")] = nil
end

function SpellReminder:BuildSpellOptions()
	local tmpTbl={}
	foreach(self.db.char.spellSetup,function (i,v) tinsert(tmpTbl,i) end)
	sort(tmpTbl)
	self.options.args.spells = defaultSpells
	foreachi(tmpTbl,function(i,spellName)
		local info = self.db.char.spellSetup[spellName]
		if info == nil or info.d == nil or info.d == 0 then return end
		local durationBuff = info.d
		
--		if durationBuff == nil and not info.detected then return end -- this can happen if the spell isnt available on this character, ie, it has been untrained
		self.options.args.spells.args["spell_"..string.gsub(spellName," ","_")] = {
			type = "group",
			order = i,
			name = spellName,
			desc = "Setup reminder for "..spellName,
			args = {
				active = {
					type = "toggle",
					order = 1,
					name = "Active",
					desc = "Track this spell?",
					get = function () return self.db.char.spellSetup[spellName].active end,
					set = function (v) self.db.char.spellSetup[spellName].active = v end,
				},
--				sharedName = {
--					type = "text",
--					order = 2,
--					name = "Shared Name",
--					desc = "A common name across unique spells, EG: only one warrior shout can be active at once.",
--					disabled = function () return self.db.char.spellSetup[spellName].active == false end,
--					get = function () return self.db.char.spellSetup[spellName].s end,
--					set = function (v) self.db.char.spellSetup[spellName].s = v end,
--					usage = "<name>",
--				},
				displayName = {
					type = "text",
					order = 2,
					name = "Display Name",
					desc = "Spell name text to display on the bar. For example an abbreviation.",
					disabled = function () return self.db.char.spellSetup[spellName].active == false end,
					get = function () return self.db.char.spellSetup[spellName].displayName end,
					set = function (v) self.db.char.spellSetup[spellName].displayName = v end,
					usage = "<name>",
				},
				reminder = {
					type = "range",
					order = 3,
					name = "Reminder",
					desc = "Reminder occurs when the spell duration remaining reaches this value.",
					min = 0,
					max = durationBuff,
					step = 1,
					disabled = function () return self.db.char.spellSetup[spellName].active == false end,
					get = function () return self.db.char.spellSetup[spellName].r end,
					set = function (v) self.db.char.spellSetup[spellName].r = v end,
				},
				color = {
					type = "color",
					order = 5,
					name = "Bar Color",
					desc = "Set the color of the reminder bar.",
					disabled = function () return self.db.char.spellSetup[spellName].active == false end,
					get = function () local c = self.db.char.spellSetup[spellName].c or defaultBarColor return c.r,c.g,c.b,c.a end,
					set = function (r, g, b, a) self.db.char.spellSetup[spellName].c = {["r"]=r, ["g"]=g, ["b"]=b, ["a"]=1} end,					
				}
			}
		}
		--[[
		if durationDebuff == nil then return end
		self.options.args.spells.args["spell_"..string.gsub(spellName," ","_")].args.reminderDebuff = {
			type = "range",
			order = 4,
			name = "Debuff Reminder",
			desc = "Reminder occurs when the spells debuff duration remaining reaches this value.",
			min = 0,
			max = durationDebuff,
			step = 1,
			disabled = function () return self.db.char.spellSetup[spellName].active == false end,
			get = function () return self.db.char.spellSetup[spellName].rd end,
			set = function (v) self.db.char.spellSetup[spellName].rd = v end,
		}]]
	end)
	
	return self.options
end

function SpellReminder:InstallWatch(spellName,rank,reminder,durationBuff)--,sharedName,reminder)
	local durationBuff, durationDebuff, rank
	if durationBuff == nil then
		durationBuff, durationDebuff, rank = self:GetDuration(spellName,rank)
	end
	if durationBuff == nil then return end -- this can happen if the spell isnt available on this character

	self:DebugPrint("Adding spell: "..spellName)
	if self.db.char.spellSetup[spellName] == nil then self.db.char.spellSetup[spellName] = {} end
	if (self.db.char.spellSetup[spellName].active == nil) then
		self:DebugPrint(spellName.." has no active")
		self.db.char.spellSetup[spellName].active = true
	end
	--self.db.char.spellSetup[spellName].s		= self.db.char.spellSetup[spellName].s or sharedName or spellName
	self.db.char.spellSetup[spellName].displayName = self.db.char.spellSetup[spellName].displayName or spellName
	self.db.char.spellSetup[spellName].rank		= rank
	
	parsedRank = string.gsub(self.db.char.spellSetup[spellName].rank,"Rank ","")
	
	if rank == nil or self.db.char.spellSetup[spellName].rank == nil or rank >= parsedRank then
		local defaultReminder = math.ceil(durationBuff*0.125)
		if defaultReminder < 5 and durationBuff > 5 then defaultReminder = 5 end
		if defaultReminder > 30 then defaultReminder = 30 end
		self.db.char.spellSetup[spellName].r	= self.db.char.spellSetup[spellName].r or reminder or defaultReminder
		self.db.char.spellSetup[spellName].d	= durationBuff
--[[		if durationDebuff ~= nil then
			local defaultReminder = math.ceil(durationDebuff*0.125)
			if defaultReminder < 5 and durationBuff > 5 then defaultReminder = 5 end
			if defaultReminder > 30 then defaultReminder = 30 end
			self.db.char.spellSetup[spellName].rd = self.db.char.spellSetup[spellName].rd or defaultReminder
			self.db.char.spellSetup[spellName].dd = durationDebuff
		end]]
	end
	self:BuildSpellOptions()
end

function SpellReminder:InstallAllSpells()
	local i = 1
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spell) then	break end
		self:InstallWatch(spell,rank)
		i = i + 1
	end
	--[[ still not found? try pets spellbook
	local i = 1
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_PET)
		if (not spell) then	break end
		self:InstallWatch(spell,rank)
		i = i + 1
	end]]
	--[[ also talents???
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
	    local numTalents = GetNumTalents(t);
	    for i=1, numTalents do
	        nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
			self:InstallWatch(nameTalent,currRank)
	    end
	end]]
	
	--self:BuildSpellOptions()
end

function SpellReminder:UNIT_SPELLCAST_SENT(caster,name,rank,target)
	self:DebugPrint("Spellcast Started: "..caster.." -> "..target.." : "..name.." ("..rank..")")
--	if target == nil or target == "" or target == "player" or target == UnitName("player") then return end
	if caster ~= "player" then return end
	if target == nil or target == "" then target = UnitName("player") end
	
	local info = self.db.char.spellSetup[name]
	if info == nil then return end
	if info.active ~= true then return end
	
	if spellInfo.casting == nil then spellInfo.casting = {} end
	
	table.insert(spellInfo.casting,{n=name, displayName=info.displayName, r=info.r, ["rank"]=rank, t=target, eventName="DURATION_ENDING_"..name..";"..(target or UnitName("player")), c=info.c})
end

function SpellReminder:UNIT_SPELLCAST_STOP(caster,name,rank)
	if caster ~= "player" then return end
	if name == nil then return end
	if rank == nil then rank = "Rank 1" end

	self:DebugPrint("Spellcast Stopped: "..caster..":"..name..":"..rank)
if true then return end 
	table.foreach(spellInfo.casting,function (i,casting)
		if casting.n == name and casting.rank == rank then
			spellInfo.casting[i] = nil
		end
	end)
end

function SpellReminder:UNIT_SPELLMISS(caster,name,rank)
	self:DebugPrint("Spellcast Missed: "..caster..":"..name..":"..rank)
	if caster ~= "player" then return end

	table.foreach(spellInfo.active,function (i,spell)
		if spell.n == name and spell.rank == rank then
			self:OnDurationEnded(spell.eventName,true)
			spellInfo.active[i] = nil
		end
	end)
end

function SpellReminder:SPELL_MISS(t)
	table.foreach(spellInfo.active, function (eventName,info)
		if info.t == t.recipientName and info.n == t.abilityName then
			self:OnDurationEnded(eventName,true)
		end
	end)
end

function SpellReminder:UNIT_SPELLCAST_SUCCEEDED(caster,name,rank)
	self:DebugPrint("Spellcast Finished: "..caster..":"..name..":"..rank)
	if caster ~= "player" then return end
	
	-- schedule an event for *padding* which ensures that a miss is detected
	local done = false
	table.foreach(spellInfo.casting,function (i,casting)
		if casting.n == name and casting.rank == rank and done == false then
			self:ScheduleEvent(self.FinalCastSuccess,0.5,self,casting)
			spellInfo.active[casting.eventName] = casting  --{n=spellname, r=reminder, t=target, eventName=casting.eventName}
			spellInfo.casting[i] = nil
			done = true
		end
	end)
	--self:CreateReminderBar(spellInfo.casting.eventName,name,info.d,info.r,spellInfo.casting.t,info.c)
end

function SpellReminder:FinalCastSuccess(castingInfo)
	self:DebugPrint("finalcast: "..castingInfo.n)
	if castingInfo == nil then return end
	if castingInfo.t == "player" or castingInfo.t == UnitName("player") and self:GetPlayerBuffDuration(castingInfo.n) ~= nil then self:ProcessAuras("player") return end
	
	buffDuration = self:GetDuration(castingInfo.n,castingInfo.rank)
	if buffDuration == nil then return end
	
	self:ProcessAuras("target")
	self:CreateReminderBar(castingInfo.eventName,castingInfo,buffDuration-0.5,castingInfo.r,castingInfo.c)
end

function SpellReminder:CreateReminderBar(e, castingInfo, duration, reminder, color, timeLeft)
	self:DebugPrint("CreateBar: "..castingInfo.n..": duration="..(duration or "no duration")..": timeleft="..(timeLeft or "none"))
	if target == UnitName("player") then target = "" end
	color = color or defaultBarColor

	-- build name
	local text = getOption("textFormat")
	text = string.gsub(text,"%%n",castingInfo.displayName or castingInfo.n)
	text = string.gsub(text,"%%r",castingInfo.rank or "")
	text = string.gsub(text,"%%t",castingInfo.t or UnitName("player"))
	if castingInfo.applications == 0 then castingInfo.applications = nil end
	text = string.gsub(text,"%%a",castingInfo.applications or "")
	text = string.gsub(text, "[(][)]", "") -- trim empty parenthesis
	text = string.gsub(text, "^%s*(.-)%s*$", "%1") -- trim whitespaces
	
	local alreadyExists = candybar:IsCandyBarRegistered(e)
	if (alreadyExists and (timeLeft == nil or (timeLeft ~= nil and timeLeft > reminder+getOption("ttg")))) or alreadyExists == false then -- either bar doesnt exist, or its been refreshed then act as new // +1 on reminder is for padding, so we dont refresh the bar if its mid growth
		self:CancelScheduledEvent("GrowBar_"..e)
		candybar:RegisterCandyBar(e, duration, text)
		candybar:RegisterCandyBarWithGroup(e,"SpellReminderNormal")
		candybar:SetCandyBarScale(e,getOption("startScale"))
		candybar:SetCandyBarText(e,text)
		candybar:SetCandyBarTimeFormat(e, self.CandyBarTimeFormat, e)
		candybar:SetCandyBarColor(e,color.r,color.g,color.b,1)
		candybar:SetCandyBarBackgroundColor(e,color.r,color.g,color.b,0.5)
		candybar:SetCandyBarIcon(e,castingInfo.icon or self:GetTexture(castingInfo.n))
		candybar:SetCandyBarCompletion(e,self.OnDurationEnded,self,e)
		candybar:StartCandyBar(e,false)

		if (getOption("baroverride") == true) then
			candybar:SetCandyBarTexture(e,sm:Fetch('statusbar', getOption("texture")))
			candybar:SetWidth(e,getOption("barwidth"))
			candybar:SetHeight(e,getOption("barheight"))
			
			local f = candybar.handlers[e].frame
			f.timertext:SetFont(sm:Fetch('font', getOption("barfont")),getOption("barfontsize")*0.9)
			f.text:SetFont(sm:Fetch('font', getOption("barfont")),getOption("barfontsize"))
			
			local timertextwidth = getOption("barfontsize") * 3.6
			f.timertext:SetWidth(timertextwidth)
			f.text:SetWidth((getOption("barwidth") - timertextwidth) * .9)
		end
		
		local adjust = 0
		if timeLeft ~= nil then
			adjust = duration-timeLeft
			candybar:SetCandyBarTimeLeft(e,timeLeft)
		end
		self:ScheduleEvent(e, self.OnDurationEnding, duration-adjust-(reminder+1), self, e)
	elseif timeLeft ~= nil then  -- this bar already exists, but its time left is less than its reminder
		candybar:SetCandyBarTimeLeft(e,timeLeft)
	end
	
	candybar:UpdateGroup("SpellReminderNormal")
	candybar:UpdateGroup("SpellReminderEmphasis")
end

function SpellReminder:CandyBarTimeFormat(bar)
	local _,totaltime,elapsed = candybar:CandyBarStatus(bar)
	local timeLeft = totaltime-elapsed
	if timeLeft > 60 then
		return string.format("%im", math.ceil(timeLeft / 60))
	else
		return string.format("%is", timeLeft)
	end
end

function SpellReminder:PLAYER_DEAD()
	table.foreach(spellInfo.active, function(e,info)
		if info ~= nil then
			self:CancelScheduledEvent(e)
			candybar:StopCandyBar(e,false)
		end
	end)
end

--  we must assume that on the death of this target, that all watched spells with this targets name apply to this death... 
function SpellReminder:COMBAT_DEATH(t)
	self:DebugPrint("death: "..t.recipientName)
	table.foreach(spellInfo.active, function (eventName,info)
		if info.t == t.recipientName or string.find(t.recipientName,info.n) ~= nil then -- call OnDurationEnded
			self:OnDurationEnded(eventName,true)
		end
	end)
end

function SpellReminder:SE_ITEM_AURA_LOST(name, rank, unknown)
	self:DebugPrint("SE_ITEM_AURA_LOST "..name)
	suffixes = {""," Weapon"}
	table.foreach(suffixes, function(_,suffix)
		local checkName = name..suffix
		table.foreach(spellInfo.active, function (eventName,info)
			if info.n == checkName and (info.t == nil or info.t == "" or info.t == "player" or info.t == UnitName("player")) then -- call OnDurationEnded
				self:OnDurationEnded(eventName)
				return
			end
		end)
	end)
end

function SpellReminder:SE_AURA_LOST(unit, name, count, icon, rank, duration)
	if unit == "target" then return end -- dont lose bars when switching target
	self:DebugPrint("SE_AURA_LOST "..name)
	suffixes = {""," Totem"}
	table.foreach(suffixes, function(_,suffix)
		local checkName = name..suffix
		table.foreach(spellInfo.active, function (eventName,info)
			if info.n == checkName and ((info.t == nil or info.t == "") or (info.t == unit or info.t == UnitName(unit))) then -- call OnDurationEnded
				self:OnDurationEnded(eventName)
				return
			end
		end)
	end)
end

function SpellReminder:AURA_LOST(t)
	self:DebugPrint("AURA_LOST "..t.abilityName)
	table.foreach(spellInfo.active, function (eventName,info)
		if info.n == t.abilityName and (info.t == nil or t.recipientName == info.t or info.t == "") then -- call OnDurationEnded
			self:OnDurationEnded(eventName)
		end
	end)
end

function SpellReminder:AURA_GAIN(t)
	self:UNIT_SPELLCAST_SENT("player",t.abilityName)
	self:UNIT_SPELLCAST_SUCCEEDED("player",t.abilityName)
end

function SpellReminder:PLAYER_REGEN_ENABLED()
if true then return end
	table.foreach(spellInfo.active, function (eventName,info)
		if info.t and info.t ~= "" then -- call OnDurationEnded
			self:OnDurationEnded(eventName,true)
		end
	end)
end

function SpellReminder:OnDurationEnded(eventName,quiet)
	if spellInfo.active[eventName] == nil then return end
	local name = spellInfo.active[eventName].n
	local target = spellInfo.active[eventName].t
	local info = self.db.char.spellSetup[name]
	if not quiet then
		self:Pour(name.." ("..target..") has EXPIRED!",1,1,1,nil,nil,nil,true)
	end
	self:CancelScheduledEvent(eventName)
	candybar:StopCandyBar(eventName,false)
	candybar:UnregisterCandyBar(eventName)
	spellInfo.active[eventName] = nil
end

function SpellReminder:OnDurationEnding(eventName,quiet)
	if spellInfo.active[eventName] == nil then return end
	local name = spellInfo.active[eventName].n
	local target = spellInfo.active[eventName].t
--	local info = self.db.char.spellSetup[name]
	local reg, t, e, r = candybar:CandyBarStatus(eventName)

	if not quiet then
		self:Pour(name.." ("..target..") over in "..math.floor(t-e-1).." seconds!",1,1,1,nil,nil,nil,true)
	end
	if getOption("disableEmphasis") ~= true then
		self:GrowCandy(eventName)
	end
end

function SpellReminder:GetTexture(name)
	local i = 1
	while true do
		local nm = GetSpellName(i, BOOKTYPE_SPELL)
		if not nm then break
		elseif nm == name then
			return GetSpellTexture(i, BOOKTYPE_SPELL)
		end
		i = i + 1
	end
	-- still not found? try pets spellbook
	local i = 1
	while true do
		local nm = GetSpellName(i, BOOKTYPE_PET)
		if not nm then break
		elseif nm == name then
			return GetSpellTexture(i, BOOKTYPE_PET)
		end
		i = i + 1
	end
	-- finally, do the talents
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
	    local numTalents = GetNumTalents(t);
	    for i=1, numTalents do
	        nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
			if nameTalent == spellName and currRank > 0 then
				local buff, debuff = self:FindDurationInTip(tiptext)
				return buff, debuff, currRank
			end
	    end
	end
end

function SpellReminder:GrowCandy(id)
	self:ScheduleEvent("GrowBar_"..id,self.GrowBar,0,self,id,GetTime()+getOption("ttg"))
end

function SpellReminder:GrowBar(id, stopTime)
	if not candybar:IsCandyBarRegistered(id) then return end
	if GetTime() > stopTime then
		candybar:SetCandyBarScale(id,getOption("stopScale"))
		candybar:RegisterCandyBarWithGroup(id,"SpellReminderEmphasis")
		return
	end
	local now = GetTime()
	local scale = (getOption("stopScale") - getOption("startScale")) * (1 - ((stopTime - now) / getOption("ttg")))

	--local centerX, centerY = self:GetCandyBarCenter(id)
	candybar:SetCandyBarScale(id,getOption("startScale") + scale)
	local effscale = UIParent:GetEffectiveScale()
	--local effscale = candybar:GetCandyBarEffectiveScale(id)
	
	local posX = ((self.db.profile.barposition["emphasis"].x*effscale) - (self.db.profile.barposition["normal"].x*effscale)) * (1-((stopTime - now) / getOption("ttg"))) 
	local posY = ((self.db.profile.barposition["emphasis"].y*effscale) - (self.db.profile.barposition["normal"].y*effscale)) * (1-((stopTime - now) / getOption("ttg")))

	local point, rframe, rpoint = candybar:GetCandyBarPoint(id)
	candybar:SetCandyBarPoint(id, point, rframe, rpoint, posX*effscale, posY*effscale)
--	candybar:SetCandyBarPoint(id, point, rframe, rpoint, posX/effscale, posY/effscale)
	
	self:ScheduleEvent("GrowBar_"..id,self.GrowBar,0,self,id,stopTime)
end
--[[function SpellReminder:GrowBar(id, stopTime)
	if not candybar:IsCandyBarRegistered(id) then return end
	if GetTime() > stopTime then
		candybar:SetCandyBarScale(id,getOption("stopScale"))
		candybar:RegisterCandyBarWithGroup(id,"SpellReminderEmphasis")
		return
	end
	local now = GetTime()
	local scale = (getOption("stopScale") - getOption("startScale")) * (1 - ((stopTime - now) / getOption("ttg")))

	candybar:SetCandyBarScale(id,getOption("startScale") + scale)
	local effscale = UIParent:GetEffectiveScale()
	
	local posX = ((self.db.profile.barposition["emphasis"].x) - (self.db.profile.barposition["normal"].x)) * (1-((stopTime - now) / getOption("ttg"))) 
	local posY = ((self.db.profile.barposition["emphasis"].y) - (self.db.profile.barposition["normal"].y)) * (1-((stopTime - now) / getOption("ttg")))
	self:Print(posX.." : "..posY)
	local point, parent, anchor, x, y = self.normalAnchor:GetPoint()
	candybar:SetCandyBarPoint(id, point, parent, anchor, posX*effscale, (posY * -1)*effscale)
	
	self:ScheduleEvent("GrowBar_"..id,self.GrowBar,0,self,id,stopTime)
end]]

function SpellReminder:GetPlayerBuffDuration(spellName)
	local i = 1
	while (UnitBuff("player",i) ~= nil) do
		name, rank, iconTexture, count, duration, timeLeft =  UnitBuff("player", i)
		if name == spellName and duration ~= nil then return duration end
		i = i + 1
	end
	local i = 1
	while (UnitBuff("pet",i) ~= nil) do
		name, rank, iconTexture, count, duration, timeLeft =  UnitBuff("pet", i)
		if name == spellName and duration ~= nil then return duration end
		i = i + 1
	end
end

local tt = AceLibrary("Gratuity-2.0")   
function SpellReminder:GetDuration(spellName, chkRank)
--[[	local toreturn = nil
	table.foreach(staticTimes , function(spell,info)
		if spellName == spell and toreturn == nil then
			toreturn = { info.durationBuff, info.durationDebuff, info.rank }
		end
	end)
	if toreturn ~= nil then return toreturn[1], toreturn[2], toreturn[3], toreturn[4] end
]]
	local lastRank = nil
	local i = 1
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spell) then	break end
		if spell == spellName then
			if (chkRank == nil and (lastRank == nil or rank > lastRank)) or (rank == chkRank) then
				lastRank = rank
				tt:SetSpell(i,BOOKTYPE_SPELL)
				local tiptext = self:GetFullTipText(tt)
				local buff, debuff = self:FindDurationInTip(tiptext)
				toreturn = { buff, debuff, rank }
			end
		end
		i = i + 1
	end
	if toreturn ~= nil then return toreturn[1], toreturn[2], toreturn[3] end
	--[[ still not found? try pets spellbook
	local i = 1
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_PET)
		if (not spell) then	break end
		if spell == spellName then
			if (chkRank == nil and (lastRank == nil or rank > lastRank)) or (rank == chkRank) then
				lastRank = rank
				tt:SetSpell(i,BOOKTYPE_PET)
				local tiptext = self:GetFullTipText(tt)
				local buff, debuff = self:FindDurationInTip(tiptext)
				toreturn = { buff, debuff, rank }
			end
		end
		i = i + 1
	end
	if toreturn ~= nil then return toreturn[1], toreturn[2], toreturn[3], true end
	]]
	--[[ finally, do the talents
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
	    local numTalents = GetNumTalents(t);
	    for i=1, numTalents do
	        nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
			if nameTalent == spellName and currRank > 0 then
				tt:SetTalent(t,i)
				local tiptext = self:GetFullTipText(tt)
				local buff, debuff = self:FindDurationInTip(tiptext)
				return buff, debuff, currRank
			end
	    end
	end]]

	return nil
end

function SpellReminder:FindDurationInTip(tiptext)
	local pre = {"for","over","lasts","up to"}
	local post = {"sec","min","hour"}
	local durationBuff = nil
	local durationDebuff = nil
	local newDur = nil
	table.foreach(pre, function(_,preVal) -- loop through prefixes
		preVal = string.lower(preVal)
		table.foreach(post, function(_,postVal)  -- loop through suffixes
			postVal = string.lower(postVal)
			for newDur in string.gmatch(string.lower(tiptext),preVal.." (%d+) "..postVal) do
				newDur = tonumber(newDur)
				if newDur ~= nil then
					if postVal == "min" then
						newDur = newDur * 60
					elseif postVal == "hour" then
						newDur = newDur * 60 * 60
					end
					if (durationBuff == nil) then
						durationBuff = newDur
					elseif (newDur > durationBuff) then
						durationDebuff = durationBuff
						durationBuff = newDur
					end
				end
			end
		end)
	end)
	
	return tonumber(durationBuff), tonumber(durationDebuff)
end

function SpellReminder:GetFullTipText(tt)
	local fullText = ""
	for i=1,tt:NumLines() do
		fullText = fullText..tt:GetLine(i)
	end
	return fullText
end

function SpellReminder:DebugPrint(text)
	if not getOption("debugmode") then return end
	self:Print(text)
end
